/****************************************************************************
 *
 * InvokeActivity.cc
 *
 * This file is part of bpel2qnbound
 *
 * Copyright (C) 2007, 2018 Moreno Marzolla
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#include <iostream>
#include "InvokeActivity.hh"
#include "ActivityVisitor.hh"
#include "WSDLOperation.hh"

using namespace std;

InvokeActivity::InvokeActivity( const std::string& name, WSDLOperation* op ) :
    Activity( name ),
    m_op( op )
{

}

void InvokeActivity::describe( ) const
{
    cout << "This is an Invoke Activity named \"" << get_name() 
         << "\" which invokes operation \"" << m_op->get_name() << "\"" 
         << endl;
}

void InvokeActivity::accept( ActivityVisitor* v )
{
    v->visit_invoke( this );
}
