/****************************************************************************
 *
 * WhileActivity.cc
 *
 * This file is part of bpel2qnbound
 *
 * Copyright (C) 2007, 2018 Moreno Marzolla
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#include "WhileActivity.hh"
#include "ActivityVisitor.hh"

#include <iostream>

using namespace std;

WhileActivity::WhileActivity( const string& name ) :
    Activity( name ),
    m_prob( 0 ),
    m_inner( 0 )
{

}

void WhileActivity::describe( void ) const 
{
    cout << "This is a While Activity named \"" << get_name()
         << "\". This activity executes the following content:" << endl
         << "====" << endl;
    if ( m_inner ) m_inner->describe();
    cout << "====" << endl
         << "with probability p=" << get_prob() << endl;
}

void WhileActivity::accept( ActivityVisitor* v )
{
    v->visit_while( this );
}
